#include <iostream>
#include "fix2.hpp"

using std::cout;

void RenderTarget::draw(const Drawable& drawable) {
  drawable.draw(*this);
}

void Shape::draw(RenderTarget& target) const {
  cout << "shape draw\n";
}

void Shape::draw(RenderTarget &target) {
  cout << "shape non-const instead\n";
}

int main() {
  RenderTarget target;
  Shape shape;

  target.draw(shape);

  shape.draw(target);
  return 0;
}
